import { Directive, Input, OnChanges, ElementRef } from '@angular/core';
import JSONFormatter from 'json-formatter-js';

@Directive({
	// tslint:disable-next-line:directive-selector
	selector: 'json-formatter'
})
export class JsonFormatterDirective implements OnChanges {

	@Input()
	data: Object;

	@Input()
	open = 2;

	constructor(private elRef: ElementRef) { }

	ngOnChanges() {
		if (this.data) {
			const formatter = new JSONFormatter(this.data, this.open);
			while (this.elRef.nativeElement.firstChild) {
				this.elRef.nativeElement.removeChild(this.elRef.nativeElement.firstChild);
			}
			this.elRef.nativeElement.appendChild(formatter.render());
		}
	}
}
